SystemOrganization addCategory: #'OpenCourses-Tests'!
SystemOrganization addCategory: #OpenCourses!
SystemOrganization addCategory: #'OpenCourses-Undergrad'!

WATask subclass: #OcRootTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcRootTask class methodsFor: 'as yet unclassified' stamp: ''!
canBeRoot
	^ true! !

!OcRootTask methodsFor: 'running' stamp: 'jsa 7/1/2013 03:11'!
go
	| loginAnswer user |
	loginAnswer := self call: OcLoginComponent new.
	loginAnswer = #registerUser
		ifTrue: [user := self call: OcRegisterComponent new]
		ifFalse: [user := loginAnswer].
	user
		ifNotNil: [self session login: user.
			self call: OcMainComponent new]! !

WAFileLibrary subclass: #OcLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcLibrary class methodsFor: 'as yet unclassified' stamp: ''!
applicationName
	^ 'OpenCourses'! !

!OcLibrary methodsFor: 'as yet unclassified' stamp: ''!
openCoursesCss
	^ '
body {
	font: normal 100% Arial, Helvetica, Verdana, sans-serif;
}
 
.generic {
	font-family: Geneva, Arial, Helvetica, sans-serif;
 	font-style: normal;
	font-weight: normal;
 	font-size: 14px;
	text-align: center;
 	color : #663300;
	background: #AAAAFF;
 	padding: 20px;
 	margin-top: 20px;
 	margin-left: auto;
	margin-right: auto;
 	border: 1px solid #663300;
 	width: 75%;
	height: auto;
}

.lightbox {
	background-color:#FFFFFF;
}

.errorMessage {
	background-color: #ffb0b0;
 	border: 1px solid #ee0000;
 	padding: 5px;
 	margin-bottom: 10px;
}

.infoMessage {
	background-color: #fbffcc;
 	border: 1px solid #eda33a;
 	padding: 5px;
 	margin-bottom: 10px;
}

.copyright {
	font-family: Geneva, Arial, Helvetica, sans-serif;
	font-size: 10px;
 	font-style: normal;
 	font-weight: normal;
 	color: #663300;
 	text-align: left;
 	margin-left: 20px;
}

.menu {
	font-family: Geneva, Arial, Helvetica, sans-serif;
	font-size: 10px;
 	font-style: normal;
 	font-weight: normal;
 	color: #663300;
	background: #FFAAAA;
 	text-align: center;
 	margin: auto;
	width: 20%;
	height: 100%;
	float: left;
}

.list {
	font-family: Geneva, Arial, Helvetica, sans-serif;
	font-size: 14px;
 	font-style: normal;
 	font-weight: normal;
 	color: #663300;
	background: #AAFFAA;
 	text-align: center;
	float: right;
	margin: auto;
	width: 80%;
	height: 100%;
}

.clear {
	clear: both;
	height: 1px;
	overflow: hidden;
	font-size:0pt;
	margin-top: -1px;
}

a {
	color : #663300;
 	text-decoration: underline;
}'! !

!OcLibrary methodsFor: 'accessing' stamp: ''!
selectorsToInclude
	^ #(#openCoursesCss )! !

WAComponent subclass: #OcGroupEditor
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcGroupEditor methodsFor: 'accessing' stamp: ''!
group
	^ group! !

!OcGroupEditor methodsFor: 'accessing' stamp: ''!
group: anObject 
	group := anObject! !

!OcGroupEditor methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self group: OcGroup new! !

!OcGroupEditor methodsFor: 'as yet unclassified' stamp: ''!
newGroup
	self group: OcGroup new! !

!OcGroupEditor methodsFor: 'as yet unclassified' stamp: ''!
renderButtonsOn: html 
	html tableData;
		tableData: [html submitButton
				callback: [self answer: true];
				 value: 'Save'.
			html submitButton
				callback: [self answer: false];
				 value: 'Cancel']! !

!OcGroupEditor methodsFor: 'rendering' stamp: ''!
renderContentOn: html 
	html div class: 'generic lightbox';
		
		with: [html heading: 'Creating group'.
			html
				form: [html
						table: [html
								tableRow: [self renderSubjectInputOn: html];
								
								tableRow: [self renderInstructorInputOn: html];
								
								tableRow: [self renderButtonsOn: html]]]]! !

!OcGroupEditor methodsFor: 'as yet unclassified' stamp: ''!
renderInstructorInputOn: html 
	html
		tableData: [html text: 'Instructor: '];
		
		tableData: [html textInput on: #instructor of: self group]! !

!OcGroupEditor methodsFor: 'as yet unclassified' stamp: ''!
renderSubjectInputOn: html 
	html
		tableData: [html text: 'Subject: '];
		
		tableData: [html textInput on: #subject of: self group]! !

WAComponent subclass: #OcLoginComponent
	instanceVariableNames: 'password messageComponent loginID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: ''!
applicationName
	^ OcLibrary applicationName! !

!OcLoginComponent methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self messageComponent: OcMessageComponent new! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: ''!
loginFailed
	self messageComponent errorMessage: 'Login failed.'! !

!OcLoginComponent methodsFor: 'accessing' stamp: ''!
loginID
	^ loginID! !

!OcLoginComponent methodsFor: 'accessing' stamp: ''!
loginID: anObject 
	loginID := anObject! !

!OcLoginComponent methodsFor: 'accessing' stamp: ''!
messageComponent
	^ messageComponent! !

!OcLoginComponent methodsFor: 'accessing' stamp: ''!
messageComponent: anObject 
	messageComponent := anObject! !

!OcLoginComponent methodsFor: 'accessing' stamp: ''!
password
	^ password! !

!OcLoginComponent methodsFor: 'accessing' stamp: ''!
password: anObject 
	password := anObject! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: ''!
registerUser
	self answer: #registerUser! !

!OcLoginComponent methodsFor: 'rendering' stamp: ''!
renderContentOn: html 
	html div class: 'generic';
		
		with: [html heading: self applicationName;
				 render: self messageComponent;
				 text: 'Please login with e-mail and password:';
				
				form: [self renderTextInputOn: html;
						 renderPasswordInputOn: html;
						 renderLoginButtonOn: html;
						 renderSignUpAnchorOn: html]]! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: ''!
renderLoginButtonOn: html 
	html submitButton
		callback: [self validateLogin];
		 text: 'Login'! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: ''!
renderPasswordInputOn: html 
	html passwordInput
		callback: [:value | self
				password: (OcUser hashPassword: value)];
		 value: ''! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: ''!
renderSignUpAnchorOn: html 
	html paragraph
		with: [html anchor
				callback: [self registerUser];
				
				with: [html text: 'Sign up for the ' , self applicationName]]! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: ''!
renderTextInputOn: html 
	html textInput on: #loginID of: self;
		 value: ''.
	html space! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'jsa 7/1/2013 01:32'!
validateLogin
	| user um |
	um := UserManager new.
	user := (um validateLogin: self loginID password: self password).
	user
		ifNotNil: [self answer: user]
		ifNil: [self loginFailed]! !

WAComponent subclass: #OcMainComponent
	instanceVariableNames: 'groupEditor menuComponent viewComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcMainComponent methodsFor: 'as yet unclassified' stamp: ''!
createNewGroup
	| answer |
	answer := self call: self groupEditor newGroup.
	answer
		ifTrue: [self listComponent items add: self groupEditor task]! !

!OcMainComponent methodsFor: 'accessing' stamp: ''!
groupEditor
	^ groupEditor! !

!OcMainComponent methodsFor: 'accessing' stamp: ''!
groupEditor: anObject 
	groupEditor := anObject! !

!OcMainComponent methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self groupEditor: OcGroupEditor new.
	Transcript show: 'before init menu comp';
		 cr.
	self menuComponent: self initializeMenuComponent.
	self viewComponent: self initializeViewComponent! !

!OcMainComponent methodsFor: 'as yet unclassified' stamp: ''!
initializeMenuComponent
	self menuComponent: OcMenuComponent new.
	self menuComponent
		addEntry: 'Edit User'
		withAction: [];
		
		addEntry: 'Create Material'
		withAction: [];
		
		addEntry: 'Create Group'
		withAction: [self createNewGroup];
		
		addEntry: 'Logoff'
		withAction: [self session logout.
			self answer: true].
	^ menuComponent! !

!OcMainComponent methodsFor: 'as yet unclassified' stamp: ''!
initializeViewComponent
	self viewComponent: OcViewComponent new.
	^ viewComponent! !

!OcMainComponent methodsFor: 'accessing' stamp: ''!
menuComponent
	^ menuComponent! !

!OcMainComponent methodsFor: 'accessing' stamp: ''!
menuComponent: anObject 
	menuComponent := anObject! !

!OcMainComponent methodsFor: 'rendering' stamp: 'cmb 6/30/2013 23:17'!
renderContentOn: html 
	html div class: 'generic';
		
		with: [html heading: 'OpenCourses'.
			html break.
			html text: self session user password.
			html break.  
			html div class: 'menu';
				 id: 'menu';
				 with: self menuComponent.
			html div class: 'list';
				 id: 'list';
				 with: self viewComponent.
			html div class: 'clear']! !

!OcMainComponent methodsFor: 'accessing' stamp: ''!
viewComponent
	^ viewComponent! !

!OcMainComponent methodsFor: 'accessing' stamp: ''!
viewComponent: anObject 
	viewComponent := anObject! !

WAComponent subclass: #OcMenuComponent
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcMenuComponent methodsFor: 'as yet unclassified' stamp: ''!
addEntry: aString withAction: aBlock 
	^ self entries add: aString -> aBlock! !

!OcMenuComponent methodsFor: 'accessing' stamp: ''!
entries
	^ entries! !

!OcMenuComponent methodsFor: 'accessing' stamp: ''!
entries: anObject 
	entries := anObject! !

!OcMenuComponent methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self entries: OrderedCollection new! !

!OcMenuComponent methodsFor: 'rendering' stamp: ''!
renderContentOn: html 
	html heading: 'Menu'.
	self entries
		do: [:entry | html anchor callback: entry value;
				 with: entry key]
		separatedBy: [html break]! !

WAComponent subclass: #OcMessageComponent
	instanceVariableNames: 'messageString messageType wasShown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcMessageComponent methodsFor: 'as yet unclassified' stamp: ''!
errorMessage: aString 
	self messageString: aString;
		 messageType: 'error';
		 wasShown: false! !

!OcMessageComponent methodsFor: 'as yet unclassified' stamp: ''!
infoMessage: aString 
	self messageString: aString;
		 messageType: 'info';
		 wasShown: false! !

!OcMessageComponent methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self wasShown: true! !

!OcMessageComponent methodsFor: 'accessing' stamp: ''!
messageString
	^ messageString! !

!OcMessageComponent methodsFor: 'accessing' stamp: ''!
messageString: anObject 
	messageString := anObject! !

!OcMessageComponent methodsFor: 'accessing' stamp: ''!
messageType
	^ messageType! !

!OcMessageComponent methodsFor: 'accessing' stamp: ''!
messageType: anObject 
	messageType := anObject! !

!OcMessageComponent methodsFor: 'rendering' stamp: ''!
renderContentOn: html 
	self wasShown
		ifTrue: [^ self].
	html div class: self messageType , 'Message';
		 with: self messageString.
	self wasShown: true! !

!OcMessageComponent methodsFor: 'accessing' stamp: ''!
wasShown
	^ wasShown! !

!OcMessageComponent methodsFor: 'accessing' stamp: ''!
wasShown: anObject 
	wasShown := anObject! !

WAComponent subclass: #OcRegisterComponent
	instanceVariableNames: 'user repeatedPassword messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: ''!
emailIsValid: anEmail 
	^ anEmail includesSubString: '@'! !

!OcRegisterComponent methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self user: OcUser new.
	self messageComponent: OcMessageComponent new! !

!OcRegisterComponent methodsFor: 'accessing' stamp: ''!
messageComponent
	^ messageComponent! !

!OcRegisterComponent methodsFor: 'accessing' stamp: ''!
messageComponent: anObject 
	messageComponent := anObject! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'jsa 7/1/2013 03:22'!
registerUser
	| um searchspecName searchspecEmail |
	um := UserManager new session: self session.
	self user userName isEmptyOrNil
		ifTrue: [^ self messageComponent infoMessage: 'Please choose a username!!'].
	searchspecName := UserSearchSpecs new userName: self user userName.
	((um search: searchspecName ) size == 0)
		ifFalse: [^ self messageComponent errorMessage: 'The username is already in use!!'].
	(self userNameIsValid: self user userName)
		ifFalse: [^ self messageComponent errorMessage: 'Invalid username (invalid character @).'].
	self user email isEmptyOrNil
		ifTrue: [^ self messageComponent infoMessage: 'Please enter your e-mail address!!'].
	(self emailIsValid: self user email)
		ifFalse: [^ self messageComponent infoMessage: 'This e-mail address is not valid'].
	searchspecEmail := UserSearchSpecs new email: self user email.
	((um search: searchspecEmail ) size == 0)
		ifFalse: [^ self messageComponent errorMessage: 'The e-mail address is already registered!!'].
	self user password = 0
		ifTrue: [^ self messageComponent infoMessage: 'Please choose a password!!'].
	self user password = self repeatedPassword
		ifFalse: [^ self messageComponent infoMessage: 'Your repeated password does not match!!'].
	um registerNewUser: self user userName password: self user password email: self user email.
	self answer: self user! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: ''!
renderCancelButtonOn: html 
	html submitButton
		callback: [self answer: nil];
		 text: 'Cancel'! !

!OcRegisterComponent methodsFor: 'rendering' stamp: ''!
renderContentOn: html 
	html div class: 'generic';
		
		with: [html heading: 'Register an account';
				 render: self messageComponent;
				
				form: [html
						table: [self renderUsernameTextInputOn: html;
								 renderEmailTextInputOn: html;
								 renderPasswordTextInputOn: html;
								 renderRepeatedPasswordTextInputOn: html.
							html
								tableRow: [html tableData;
										tableData: [self renderSubmitButtonOn: html.
											html space.
											self renderCancelButtonOn: html]]]]]! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: ''!
renderEmailTextInputOn: html 
	html
		tableRow: [html tableData: 'E-mail';
				
				tableData: [html textInput
						callback: [:value | self user email: value];
						 value: self user email]]! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: ''!
renderPasswordTextInputOn: html 
	html
		tableRow: [html tableData: 'Password';
				
				tableData: [html passwordInput
						callback: [:value | self user
								password: (OcUser hashPassword: value)]]]! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: ''!
renderRepeatedPasswordTextInputOn: html 
	html
		tableRow: [html tableData: 'Repeat password';
				
				tableData: [html passwordInput
						callback: [:value | self
								repeatedPassword: (OcUser hashPassword: value)]]]! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: ''!
renderSubmitButtonOn: html 
	html submitButton
		callback: [self registerUser];
		 text: 'Register'! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: ''!
renderUsernameTextInputOn: html 
	html
		tableRow: [html tableData: 'Username';
				
				tableData: [html textInput
						callback: [:value | self user userName: value];
						 value: self user userName]]! !

!OcRegisterComponent methodsFor: 'accessing' stamp: ''!
repeatedPassword
	^ repeatedPassword! !

!OcRegisterComponent methodsFor: 'accessing' stamp: ''!
repeatedPassword: anObject 
	repeatedPassword := anObject! !

!OcRegisterComponent methodsFor: 'accessing' stamp: ''!
user
	^ user! !

!OcRegisterComponent methodsFor: 'accessing' stamp: ''!
user: anObject 
	user := anObject! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: ''!
userNameIsValid: anUserName 
	^ (anUserName includesSubString: '@') not! !

WAComponent subclass: #OcViewComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcViewComponent methodsFor: 'rendering' stamp: ''!
renderContentOn: html 
	html heading: 'Workspace'.
	html break.
	html anchor
		callback: [];
		 with: 'Material1'.
	html break.
	html anchor
		callback: [];
		 with: 'Material2'.
	html break.
	html anchor
		callback: [];
		 with: 'Material3'! !

!OcViewComponent methodsFor: 'as yet unclassified' stamp: ''!
renderGroup: aGroup asRowOn: html 
	html
		tableData: [html tableData: aGroup subject;
				 tableData: aGroup instructor;
				 tableData: aGroup userList size asString + ' alunos']! !

!OcViewComponent methodsFor: 'as yet unclassified' stamp: ''!
renderMaterial: aMaterial asRowOn: html 
	html
		tableData: [html tableData: aMaterial creationDate asString;
				 tableData: aMaterial title;
				 tableData: aMaterial owner;
				 tableData: aMaterial materialDescription]! !

Object subclass: #DataBaseCollection
	instanceVariableNames: 'list imageDatabase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!DataBaseCollection methodsFor: 'as yet unclassified' stamp: 'Su 6/30/2013 21:00'!
add: anObject 
	imageDatabase transaction: [ self list add: anObject. 
								   imageDatabase saveImageWithoutMonitor].
	! !

!DataBaseCollection methodsFor: 'as yet unclassified' stamp: 'Su 6/30/2013 21:03'!
edit: anObject 
	| storedObject |
	imageDatabase transaction: 
		[storedObject := self list like: anObject.
		storedObject
			ifNil: [Error signal: 'Object not found']
			ifNotNil: [ storedObject copyFrom: anObject.
			       imageDatabase saveImageWithoutMonitor.]]! !

!DataBaseCollection methodsFor: 'as yet unclassified' stamp: ''!
find: anObject 
	^ self list like: anObject! !

!DataBaseCollection methodsFor: 'as yet unclassified' stamp: ''!
findBySpec: anSpec 
	^ list
		select: [:object | anSpec matches: object]! !

!DataBaseCollection methodsFor: 'accessing' stamp: 'Su 6/30/2013 21:25'!
imageDatabase
	^ imageDatabase! !

!DataBaseCollection methodsFor: 'accessing' stamp: 'Su 6/30/2013 21:25'!
imageDatabase: anObject
	imageDatabase := anObject! !

!DataBaseCollection methodsFor: 'as yet unclassified' stamp: ''!
includes: anObject 
	^ self list includes: anObject! !

!DataBaseCollection methodsFor: 'private' stamp: ''!
list
	^ list! !

!DataBaseCollection methodsFor: 'accessing' stamp: 'Su 6/30/2013 21:41'!
list: anObject 
	self imageDatabase transaction:  [list := anObject.
		self imageDatabase saveImageWithoutMonitor].! !

!DataBaseCollection methodsFor: 'as yet unclassified' stamp: 'Su 6/30/2013 21:06'!
remove: anObject 
	imageDatabase transaction:  [self list remove: anObject.
		imageDatabase saveImageWithoutMonitor]! !

Object subclass: #FakeFile
	instanceVariableNames: 'title contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!FakeFile methodsFor: 'accessing' stamp: ''!
contents
	^ contents! !

!FakeFile methodsFor: 'accessing' stamp: ''!
contents: anObject 
	contents := anObject! !

!FakeFile methodsFor: 'accessing' stamp: ''!
title
	^ title! !

!FakeFile methodsFor: 'accessing' stamp: ''!
title: anObject 
	title := anObject! !

Object subclass: #GroupManager
	instanceVariableNames: 'groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!GroupManager methodsFor: 'management' stamp: 'Su 7/1/2013 04:08'!
createGroup: groupName courseIdentifier: courseIdentifier topic: topic instructor: instructor userList: userList ownerList: ownerList materialList: materialList beginDate: beginDate endDate: endDate  
	| group user |
	user := Session user.
	"UserManager new canCreateGroup"
		true
		ifTrue: [group := OcGroup new groupName: groupName;
						 topic: topic;
						 courseIdentifier: courseIdentifier; 
						 userList: userList;
						 instructor: instructor;
						 ownerList: ownerList;
						 materialList: materialList; 
						 beginDate: beginDate;
						 endDate: endDate;
						 creator: user.
			group generateId.
			self groups add: group]
		ifFalse: [Error signal: 'User doesn''t have permission to create this group']! !

!GroupManager methodsFor: 'management' stamp: 'Su 7/1/2013 02:40'!
editGroup: anEditedGroup 
	| groupToEdit |
	groupToEdit := groups find: anEditedGroup.
	groupToEdit
		ifNil: [Error signal: 'Group doesn''t exist.']
		ifNotNil: ["(UserManager new canEditGroup: groupToEdit owner)
				ifFalse: [Error signal: 'User doesn''t have permission to edit this material']."
			groups edit: anEditedGroup]! !

!GroupManager methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:19'!
groups
	^ groups! !

!GroupManager methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:19'!
groups: anObject
	groups := anObject! !

!GroupManager methodsFor: 'as yet unclassified' stamp: 'Su 7/1/2013 02:42'!
initialize
	groups := OcImageDatabase new groups.! !

!GroupManager methodsFor: 'management' stamp: 'Su 7/1/2013 02:49'!
removeGroup: aGroup
	(groups includes: aGroup)
		ifTrue: ["(UserManager new canRemoveMaterial: aMaterial owner)"
				(true)
				ifTrue: [groups remove: aGroup]
				ifFalse: [Error signal: 'User doesn''t have permission to remove this group']]
		ifFalse: [Error signal: 'Group doenst exist']! !

!GroupManager methodsFor: 'searching' stamp: 'Su 7/1/2013 04:06'!
search: aGroupSearchSpecs 
	^ self groups findBySpec: aGroupSearchSpecs! !

Object subclass: #MaterialManager
	instanceVariableNames: 'session materials'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!MaterialManager methodsFor: 'management' stamp: 'jsa 7/1/2013 03:00'!
editMaterial: anEditedMaterial 
	| materialToEdit um |
	um := UserManager new session: self session.
	materialToEdit := materials find: anEditedMaterial.
	materialToEdit
		ifNil: [Error signal: 'Material doesn''t exist.']
		ifNotNil: [(um canEditMaterial: materialToEdit owner)
				ifFalse: [Error signal: 'User doesn''t have permission to edit this material'].
			materials edit: anEditedMaterial]! !

!MaterialManager methodsFor: 'as yet unclassified' stamp: 'Su 7/1/2013 02:41'!
initialize
	materials := OcImageDatabase new materials! !

!MaterialManager methodsFor: 'accessing' stamp: ''!
materials
	^ materials! !

!MaterialManager methodsFor: 'accessing' stamp: ''!
materials: anObject 
	materials := anObject! !

!MaterialManager methodsFor: 'management' stamp: 'jsa 7/1/2013 03:01'!
removeMaterial: aMaterial 
	| um |
	um := UserManager new session: self session.  
	(materials includes: aMaterial)
		ifTrue: [(um canRemoveMaterial: aMaterial owner)
				ifTrue: [materials remove: aMaterial]
				ifFalse: [Error signal: 'User doesn''t have permission to remove this material']]
		ifFalse: [Error signal: 'Material doenst exist']! !

!MaterialManager methodsFor: 'searching' stamp: ''!
search: aDidacticMaterialSearchSpecs 
	^ self materials findBySpec: aDidacticMaterialSearchSpecs! !

!MaterialManager methodsFor: 'accessing' stamp: 'jsa 7/1/2013 02:02'!
session
	^ session! !

!MaterialManager methodsFor: 'accessing' stamp: 'jsa 7/1/2013 02:02'!
session: anObject
	session := anObject! !

!MaterialManager methodsFor: 'management' stamp: 'jsa 7/1/2013 02:57'!
submitMaterial: submittedFile title: title authors: authorsList description: description type: type licence: licence tags: tags 
	| material now user um |
	now := TimeStamp now.
	user := self session user.
	um := UserManager new session: self session.
	um canSubmitMaterial
		ifTrue: [material := OcDidacticMaterial new file: submittedFile;
						 title: title;
						 authors: authorsList;
						 materialDescription: description;
						 type: type;
						 licence: licence;
						 tags: tags;
						 creationDate: now;
						 lastUploadDate: now;
						 owner: user.
			material generateId.
			self materials add: material]
		ifFalse: [Error signal: 'User doesn''t have permission to submit material']! !

Object subclass: #OcDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcDatabase methodsFor: 'as yet unclassified' stamp: ''!
connect
	^ true! !

!OcDatabase methodsFor: 'as yet unclassified' stamp: ''!
connectionFailed
	^ false! !

!OcDatabase methodsFor: 'as yet unclassified' stamp: ''!
disconnect
	^ true! !

OcDatabase subclass: #OcImageDatabase
	instanceVariableNames: ''
	classVariableNames: 'Admin GroupsCollection MaterialsCollection TopicsCollection Uid UniqueInstance Users UsersCollection WriteMutex'
	poolDictionaries: ''
	category: 'OpenCourses'!

OcImageDatabase class
	instanceVariableNames: 'Users'!

OcImageDatabase class
	instanceVariableNames: 'Users'!

!OcImageDatabase class methodsFor: 'accessing' stamp: ''!
admin
	^ Admin! !

!OcImageDatabase class methodsFor: 'accessing' stamp: ''!
admin: anObject 
	Admin := anObject! !

!OcImageDatabase class methodsFor: 'accessing' stamp: 'Su 7/1/2013 04:14'!
groups
	"^ Groups
		ifNil: [Groups := SortedCollection new]"! !

!OcImageDatabase class methodsFor: 'accessing' stamp: ''!
groups: anObject 
	Groups := anObject! !

!OcImageDatabase class methodsFor: 'accessing' stamp: 'Su 7/1/2013 02:14'!
groupsCollection
	^GroupsCollection 
			ifNil: [GroupsCollection := DataBaseCollection new.
			GroupsCollection imageDatabase: UniqueInstance.
			GroupsCollection list: Set new.  
			^ GroupsCollection].! !

!OcImageDatabase class methodsFor: 'accessing' stamp: 'Su 7/1/2013 02:16'!
groupsCollection: anObject
	GroupsCollection := anObject.
	GroupsCollection ifNotNil:  [GroupsCollection imageDatabase: UniqueInstance]     ! !

!OcImageDatabase class methodsFor: 'accessing' stamp: 'Su 6/30/2013 22:32'!
materialsCollection
	^MaterialsCollection
		ifNil: [MaterialsCollection := DataBaseCollection new.
			MaterialsCollection imageDatabase: UniqueInstance.
			MaterialsCollection list: Set new.  
			^ MaterialsCollection].! !

!OcImageDatabase class methodsFor: 'accessing' stamp: 'Su 6/30/2013 22:32'!
materialsCollection: anObject 
	MaterialsCollection := anObject.
	MaterialsCollection ifNotNil:  [MaterialsCollection imageDatabase: UniqueInstance]       ! !

!OcImageDatabase class methodsFor: 'as yet unclassified' stamp: 'Su 6/30/2013 22:25'!
new
	^UniqueInstance ifNil: [UniqueInstance := self basicNew initialize]  ! !

!OcImageDatabase class methodsFor: 'accessing' stamp: 'Su 7/1/2013 02:17'!
topicsCollection
	^TopicsCollection
		ifNil: [TopicsCollection := DataBaseCollection new.
			TopicsCollection imageDatabase: UniqueInstance.
			TopicsCollection list: Set new.  
			^ TopicsCollection].! !

!OcImageDatabase class methodsFor: 'accessing' stamp: 'Su 7/1/2013 02:18'!
topicsCollection: anObject
	TopicsCollection := anObject.
	TopicsCollection ifNotNil:  [TopicsCollection imageDatabase: UniqueInstance]    ! !

!OcImageDatabase class methodsFor: 'accessing' stamp: ''!
uid
	^ Uid! !

!OcImageDatabase class methodsFor: 'accessing' stamp: ''!
uid: anObject 
	Uid := anObject! !

!OcImageDatabase class methodsFor: 'accessing' stamp: 'Su 6/30/2013 22:31'!
usersCollection
	^ UsersCollection
		ifNil: [UsersCollection := DataBaseCollection new.
			 UsersCollection imageDatabase: UniqueInstance.
			 UsersCollection list: Set new.
			^ UsersCollection]! !

!OcImageDatabase class methodsFor: 'accessing' stamp: 'Su 6/30/2013 22:31'!
usersCollection: anObject 
	UsersCollection := anObject.
	UsersCollection ifNotNil:  [UsersCollection imageDatabase: UniqueInstance]! !

!OcImageDatabase class methodsFor: 'as yet unclassified' stamp: ''!
writeMutex
	^ WriteMutex
		ifNil: [WriteMutex := Monitor new]! !

!OcImageDatabase class methodsFor: 'accessing' stamp: ''!
writeMutex: anObject 
	WriteMutex := anObject! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: ''!
admin
	^ self class admin! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: ''!
admin: anAdmin 
	self class admin: anAdmin.
	self saveImage.
	^ anAdmin! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: 'jsa 6/30/2013 23:37'!
blankData
	UniqueInstance := nil.
	self class new.
	self class usersCollection: nil.
	self class materialsCollection: nil.
	self class admin: nil.
	self class uid: 0! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: 'Su 7/1/2013 02:21'!
groups
	^ self class groupsCollection.! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: ''!
materials
	^ self class materialsCollection! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: ''!
nextUid
	| nextId |
	self class writeMutex
		critical: [nextId := self class uid.
			self class uid: self class uid + 1.
			self saveImageWithoutMonitor].
	^ nextId! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: ''!
saveImage
	self class writeMutex
		critical: [self saveImageWithoutMonitor]! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: 'Su 7/1/2013 04:15'!
saveImageWithoutMonitor
	SmalltalkImage current saveSession! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: 'Su 7/1/2013 02:22'!
topics
	self class topicsCollection.! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: 'Su 6/30/2013 22:48'!
transaction: aBlock
	self class writeMutex
		critical: aBlock! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: ''!
users
	^ self class usersCollection! !

OcImageDatabase subclass: #OcImageDatabaseMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Tests'!

!OcImageDatabaseMock methodsFor: 'as yet unclassified' stamp: 'jsa 7/1/2013 01:40'!
saveImageWithoutMonitor! !

Object subclass: #OcObject
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

OcObject subclass: #DidaticStructure
	instanceVariableNames: 'creator ownerList visible topic'
	classVariableNames: 'StructureId'
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!DidaticStructure commentStamp: 'RFG 5/11/2013 13:53' prior: 0!
Mudar o nome dessa classe. It represents: Lecture U Group U Subject U Courses!

DidaticStructure subclass: #Course
	instanceVariableNames: 'courseName subjectList userList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!Course commentStamp: 'RFG 5/2/2013 11:43' prior: 0!
Represents a course in the system.!

!Course class methodsFor: 'instance creation' stamp: ''!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId 
	| newCourse aTopic sys |
	newCourse := super
				newNamed: aName
				withId: anId
				by: anUserId
				onTopic: aTopicId.
	newCourse userList isNil
		ifTrue: [newCourse userList: OrderedCollection new].
	newCourse subjectList isNil
		ifTrue: [newCourse subjectList: OrderedCollection new].
	sys := System create.
	aTopic := sys findTopic: aTopicId.
	aTopic addCourse: newCourse.
	^ newCourse! !

!Course methodsFor: 'inclusion' stamp: ''!
addSubject: anId 
	subjectList add: anId! !

!Course methodsFor: 'inclusion' stamp: ''!
addUser: anId 
	userList add: anId! !

!Course methodsFor: 'accessing' stamp: 'Su 7/1/2013 01:48'!
courseName
	^ courseName! !

!Course methodsFor: 'accessing' stamp: 'Su 7/1/2013 01:48'!
courseName: anObject
	courseName := anObject! !

!Course methodsFor: 'deletion' stamp: ''!
delete
	| system topic user |
	system := System create.
	userList
		do: [:userId | 
			user := system findUser: userId.
			user withdrawCourse: self id].
	topic := system findTopic: self topic.
	topic courseTable removeAt: self id! !

!Course methodsFor: 'remotion' stamp: ''!
removeSubject: anId 
	subjectList remove: anId! !

!Course methodsFor: 'remotion' stamp: ''!
removeUser: anId 
	userList remove: anId! !

!Course methodsFor: 'accessing' stamp: ''!
subjectList
	^ subjectList! !

!Course methodsFor: 'accessing' stamp: ''!
subjectList: aListOfIds 
	subjectList := aListOfIds! !

!Course methodsFor: 'accessing' stamp: ''!
userList
	^ userList! !

!Course methodsFor: 'accessing' stamp: ''!
userList: aListOfIds 
	userList := aListOfIds! !

!DidaticStructure class methodsFor: 'instance creation' stamp: ''!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId 
	| newDidaticStructure |
	newDidaticStructure := self new.
	newDidaticStructure id: anId.
	newDidaticStructure name: aName.
	newDidaticStructure creator: anUserId.
	newDidaticStructure topic: aTopicId.
	newDidaticStructure visible: False.
	newDidaticStructure ownerList isNil
		ifTrue: [newDidaticStructure ownerList: OrderedCollection new].
	^ newDidaticStructure! !

!DidaticStructure methodsFor: 'accessing' stamp: ''!
creator
	^ creator! !

!DidaticStructure methodsFor: 'accessing' stamp: ''!
creator: anId 
	creator := anId! !

!DidaticStructure methodsFor: 'deletion' stamp: ''!
delete
	^ self subclassResponsibility! !

!DidaticStructure methodsFor: 'accessing' stamp: 'Su 7/1/2013 02:55'!
id
	"^ id"
	^ super id.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'Su 7/1/2013 02:55'!
id: anID
	"id := anID"
	super id: anID.! !

!DidaticStructure methodsFor: 'accessing' stamp: ''!
ownerList
	^ ownerList! !

!DidaticStructure methodsFor: 'accessing' stamp: ''!
ownerList: aListOfIds 
	ownerList := aListOfIds! !

!DidaticStructure methodsFor: 'accessing' stamp: ''!
topic
	^ topic! !

!DidaticStructure methodsFor: 'accessing' stamp: ''!
topic: aTopic 
	topic := aTopic! !

!DidaticStructure methodsFor: 'accessing' stamp: ''!
visible
	^ visible! !

!DidaticStructure methodsFor: 'accessing' stamp: ''!
visible: boolean 
	visible := boolean! !

DidaticStructure subclass: #Lecture
	instanceVariableNames: 'lectureName subject userList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!Lecture commentStamp: 'RFG 5/10/2013 18:02' prior: 0!
Represents a Lecture of a Subject!

!Lecture class methodsFor: 'instance creation' stamp: ''!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId onSubject: aSubjectId 
	| newLecture sys |
	newLecture := super
				newNamed: aName
				withId: anId
				by: anUserId
				onTopic: aTopicId.
	newLecture subject: aSubjectId.
	newLecture userList isNil
		ifTrue: [newLecture subjectList: OrderedCollection new].
	sys := System create.
	(sys findSubject: aSubjectId)
		addLecture: newLecture.
	^ newLecture! !

!Lecture methodsFor: 'deletion' stamp: ''!
delete
	| subject sys |
	sys := System create.
	subject := sys findSubject: self subject.
	subject lectureTable removeKey: self id! !

!Lecture methodsFor: 'accessing' stamp: 'Su 7/1/2013 01:48'!
lectureName
	^ lectureName! !

!Lecture methodsFor: 'accessing' stamp: 'Su 7/1/2013 01:48'!
lectureName: anObject
	lectureName := anObject! !

!Lecture methodsFor: 'remotion' stamp: ''!
removeUser: anId 
	userList remove: anId! !

!Lecture methodsFor: 'accessing' stamp: ''!
subject
	^ subject! !

!Lecture methodsFor: 'accessing' stamp: ''!
subject: anSubjectId 
	subject := anSubjectId! !

!Lecture methodsFor: 'accessing' stamp: ''!
userList
	^ userList! !

!Lecture methodsFor: 'accessing' stamp: ''!
userList: aListOfIds 
	userList := aListOfIds! !

DidaticStructure subclass: #OcGroup
	instanceVariableNames: 'userList instructor groupName beginDate EndDate materialList courseIdentifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!OcGroup commentStamp: 'RFG 5/9/2013 13:46' prior: 0!
Represents a group in the system. Set of students at inscribed in a subject with a instructor.!

!OcGroup class methodsFor: 'instance creation' stamp: ''!
newNamed: aName withId: anId by: anUserId onSubject: anSubjectId andInstructor: anInstructorId 
	| newGroup system topicId subject |
	system := System create.
	subject := system findSubject: anSubjectId.
	topicId := subject topic.
	newGroup := super
				newNamed: aName
				withId: anId
				by: anUserId
				onTopic: topicId.
	newGroup instructor: anInstructorId.
	newGroup subject: anSubjectId.
	newGroup userList isNil
		ifTrue: [newGroup userList: OrderedCollection new].
	subject addGroup: newGroup.
	^ newGroup! !

!OcGroup methodsFor: 'adding' stamp: ''!
addUser: anId 
	userList add: anId! !

!OcGroup methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:16'!
beginDate
	^ beginDate! !

!OcGroup methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:16'!
beginDate: anObject
	beginDate := anObject! !

!OcGroup methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:47'!
courseIdentifier
	^ courseIdentifier! !

!OcGroup methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:47'!
courseIdentifier: anObject
	courseIdentifier := anObject! !

!OcGroup methodsFor: 'deletion' stamp: ''!
delete
	| subject sys subjectId groupId |
	groupId := self id.
	subjectId := self subject.
	userList
		do: [:user | user leaveGroup: groupId].
	sys := System create.
	subject := sys findSubject: subjectId.
	subject groupTable removeKey: groupId! !

!OcGroup methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:16'!
endDate
	^ EndDate! !

!OcGroup methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:16'!
endDate: anObject
	EndDate := anObject! !

!OcGroup methodsFor: 'accessing' stamp: 'Su 7/1/2013 01:49'!
groupName
	^ groupName! !

!OcGroup methodsFor: 'accessing' stamp: 'Su 7/1/2013 01:49'!
groupName: anObject
	groupName := anObject! !

!OcGroup methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	userList = OrderedCollection new! !

!OcGroup methodsFor: 'accessing' stamp: ''!
instructor
	^ instructor! !

!OcGroup methodsFor: 'accessing' stamp: ''!
instructor: anUserId 
	instructor := anUserId! !

!OcGroup methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:39'!
materialList
	^ materialList! !

!OcGroup methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:39'!
materialList: anObject
	materialList := anObject! !

!OcGroup methodsFor: 'remotion' stamp: ''!
removeUser: anId 
	| userId user system |
	userId := userList removeAt: anId.
	system := System create.
	user := system findUser: userId.
	user groupList remove: self id! !

!OcGroup methodsFor: 'accessing' stamp: ''!
subject
	^ subject! !

!OcGroup methodsFor: 'accessing' stamp: ''!
subject: anSubjectId 
	subject := anSubjectId! !

!OcGroup methodsFor: 'accessing' stamp: ''!
userList
	^ userList! !

!OcGroup methodsFor: 'accessing' stamp: ''!
userList: aListOfIds 
	userList := aListOfIds! !

DidaticStructure subclass: #Subject
	instanceVariableNames: 'groupTable lectureTable responsible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!Subject commentStamp: 'RFG 5/6/2013 15:55' prior: 0!
Represents a Subject in the system.!

!Subject class methodsFor: 'instance creation' stamp: ''!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId 
	| newSubject |
	newSubject := self
				newNamed: aName
				withId: anId
				by: anUserId
				onTopic: aTopicId
				managedBy: anUserId.
	^ newSubject! !

!Subject class methodsFor: 'instance creation' stamp: ''!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId managedBy: responsibleId 
	| newSubject topic sys |
	newSubject := super
				newNamed: aName
				withId: anId
				by: anUserId
				onTopic: aTopicId.
	newSubject responsible: responsibleId.
	newSubject groupTable isNil
		ifTrue: [newSubject groupTable: Dictionary new].
	newSubject lectureTable isNil
		ifTrue: [newSubject lectureTable: Dictionary new].
	sys := System create.
	topic := sys findTopic: aTopicId.
	topic addSubject: newSubject.
	^ newSubject! !

!Subject methodsFor: 'adding' stamp: ''!
addGroup: aGroup 
	groupTable at: aGroup id put: aGroup! !

!Subject methodsFor: 'adding' stamp: ''!
addLecture: aLecture 
	groupTable at: aLecture id put: aLecture! !

!Subject methodsFor: 'deletion' stamp: ''!
delete
	| system topic |
	groupTable
		do: [:group | group delete].
	lectureTable
		do: [:lecture | lecture delete].
	system := System create.
	topic := system findTopic: self topic.
	topic subjectTable removeAt: self id! !

!Subject methodsFor: 'accessing' stamp: ''!
findGroup: anGroupId 
	^ groupTable at: anGroupId! !

!Subject methodsFor: 'accessing' stamp: ''!
findLecture: anLectureId 
	^ lectureTable at: anLectureId! !

!Subject methodsFor: 'accessing' stamp: ''!
groupTable
	^ groupTable! !

!Subject methodsFor: 'accessing' stamp: ''!
groupTable: aDict 
	groupTable := aDict! !

!Subject methodsFor: 'accessing' stamp: ''!
lectureTable
	^ lectureTable! !

!Subject methodsFor: 'accessing' stamp: ''!
lectureTable: aDict 
	lectureTable := aDict! !

!Subject methodsFor: 'remotion' stamp: ''!
removeGroup: aGroupId 
	| group |
	group := self findGroup: aGroupId.
	group delete! !

!Subject methodsFor: 'remotion' stamp: ''!
removeLecture: aLectureId 
	| lecture |
	lecture := self findLecture: aLectureId.
	lecture delete! !

!Subject methodsFor: 'accessing' stamp: ''!
responsible
	^ responsible! !

!Subject methodsFor: 'accessing' stamp: ''!
responsible: anUserId 
	responsible := anUserId! !

DidaticStructure subclass: #Topic
	instanceVariableNames: 'courseTable subjectTable moderatorList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!Topic commentStamp: 'RFG 5/2/2013 13:44' prior: 0!
Represents a topic in the system.!

!Topic class methodsFor: 'instance creation' stamp: ''!
newNamed: aName withId: anId by: anUserId 
	| newTopic sys |
	newTopic := super
				newNamed: aName
				withId: anId
				by: anUserId
				onTopic: anId.
	newTopic courseTable isNil
		ifTrue: [newTopic courseTable: Dictionary new].
	newTopic subjectTable isNil
		ifTrue: [newTopic subjectTable: Dictionary new].
	newTopic moderatorList isNil
		ifTrue: [newTopic moderatorList: OrderedCollection new].
	sys := System create.
	sys addTopic: newTopic.
	^ newTopic! !

!Topic methodsFor: 'adding' stamp: ''!
addCourse: aCourse 
	courseTable at: aCourse id put: aCourse! !

!Topic methodsFor: 'adding' stamp: ''!
addModerator: aModeratorId 
	moderatorList add: aModeratorId! !

!Topic methodsFor: 'adding' stamp: ''!
addSubject: aSubject 
	subjectTable at: aSubject id put: aSubject! !

!Topic methodsFor: 'accessing' stamp: ''!
courseTable
	^ courseTable! !

!Topic methodsFor: 'accessing' stamp: ''!
courseTable: aDictionary 
	courseTable := aDictionary! !

!Topic methodsFor: 'accessing' stamp: ''!
creator
	^ creator! !

!Topic methodsFor: 'accessing' stamp: ''!
creator: anUserId 
	creator := anUserId! !

!Topic methodsFor: 'deletion' stamp: ''!
delete
	| system topic |
	courseTable
		do: [:course | course delete].
	subjectTable
		do: [:subject | subject delete].
	system := System create.
	topic := system findTopic: self topic.
	system removeTopic: self id! !

!Topic methodsFor: 'accessing' stamp: ''!
findCourse: aCourseId 
	^ courseTable
		at: aCourseId
		ifAbsent: [^ nil]! !

!Topic methodsFor: 'accessing' stamp: ''!
findSubject: aSubjectId 
	^ subjectTable
		at: aSubjectId
		ifAbsent: [^ nil]! !

!Topic methodsFor: 'accessing' stamp: ''!
id
	^ id! !

!Topic methodsFor: 'accessing' stamp: ''!
id: anId 
	id := anId! !

!Topic methodsFor: 'accessing' stamp: ''!
moderatorList
	^ moderatorList! !

!Topic methodsFor: 'accessing' stamp: ''!
moderatorList: anOrderedCollection 
	moderatorList := anOrderedCollection! !

!Topic methodsFor: 'accessing' stamp: ''!
name
	^ name! !

!Topic methodsFor: 'accessing' stamp: ''!
name: aName 
	name := aName! !

!Topic methodsFor: 'remotion' stamp: ''!
removeCourse: aCourseId 
	| course |
	course := self findGroup: aCourseId.
	course delete! !

!Topic methodsFor: 'remotion' stamp: ''!
removeSubject: aSubjectId 
	| subject |
	subject := self findSubject: aSubjectId.
	subject delete! !

!Topic methodsFor: 'accessing' stamp: ''!
subjectTable
	^ subjectTable! !

!Topic methodsFor: 'accessing' stamp: ''!
subjectTable: aDictionary 
	subjectTable := aDictionary! !

OcObject subclass: #OcDidacticMaterial
	instanceVariableNames: 'file title authors owner licence creationDate lastUploadDate type tags materialDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
authors
	^ authors! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
authors: anObject 
	authors := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
creationDate
	^ creationDate! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
creationDate: anObject 
	creationDate := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
file
	^ file! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
file: anObject 
	file := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
lastUploadDate
	^ lastUploadDate! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
lastUploadDate: anObject 
	lastUploadDate := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
licence
	^ licence! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
licence: anObject 
	licence := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
materialDescription
	^ materialDescription! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
materialDescription: anObject 
	materialDescription := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
owner
	^ owner! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
owner: anObject 
	owner := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
tags
	^ tags! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
tags: anObject 
	tags := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
title
	^ title! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
title: anObject 
	title := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
type
	^ type! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: ''!
type: anObject 
	type := anObject! !

!OcObject methodsFor: 'as yet unclassified' stamp: 'jsa 7/1/2013 01:30'!
= anotherObject 
	anotherObject
		ifNotNil: [^ (anotherObject isKindOf: self class) and: [anotherObject id = self id]].
	^ false! !

!OcObject methodsFor: 'as yet unclassified' stamp: ''!
copyFrom: anotherObject 
	| mine his |
	mine := self class allInstVarNames.
	his := anotherObject class allInstVarNames.
	1
		to: (mine size min: his size)
		do: [:ind | ((mine at: ind)
					= (his at: ind) and: (anotherObject instVarAt: ind) isNil not)
				ifTrue: [self
						instVarAt: ind
						put: (anotherObject instVarAt: ind)]]! !

!OcObject methodsFor: 'as yet unclassified' stamp: ''!
generateId
	| db |
	db := OcImageDatabase new.
	self id: db nextUid! !

!OcObject methodsFor: 'as yet unclassified' stamp: ''!
hash
	^ self id hash! !

!OcObject methodsFor: 'accessing' stamp: ''!
id
	^ id! !

!OcObject methodsFor: 'accessing' stamp: ''!
id: anObject 
	id := anObject! !

OcObject subclass: #OcUser
	instanceVariableNames: 'password email userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcUser class methodsFor: 'as yet unclassified' stamp: ''!
hashPassword: aString 
	^ aString
		ifEmpty: [0]
		ifNotEmpty: [GRPlatform current secureHashFor: aString]! !

!OcUser methodsFor: 'accessing' stamp: ''!
email
	^ email! !

!OcUser methodsFor: 'accessing' stamp: ''!
email: anObject 
	email := anObject! !

!OcUser methodsFor: 'checking' stamp: ''!
isLogged
	^ Session user = self! !

!OcUser methodsFor: 'accessing' stamp: ''!
password
	^ password! !

!OcUser methodsFor: 'accessing' stamp: ''!
password: anObject 
	password := anObject! !

!OcUser methodsFor: 'accessing' stamp: ''!
userName
	^ userName! !

!OcUser methodsFor: 'accessing' stamp: ''!
userName: anObject 
	userName := anObject! !

Object subclass: #SearchSpecs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

SearchSpecs subclass: #DidacticMaterialSearchSpecs
	instanceVariableNames: 'title materialDescription authors owner licence creationDateStart creationDateEnd lastUploadDateStart lastUploadDateEnd type tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
authors
	^ authors! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
authors: anObject 
	authors := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
creationDateEnd
	^ creationDateEnd! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
creationDateEnd: anObject 
	creationDateEnd := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
creationDateStart
	^ creationDateStart! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
creationDateStart: anObject 
	creationDateStart := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
lastUploadDateEnd
	^ lastUploadDateEnd! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
lastUploadDateEnd: anObject 
	lastUploadDateEnd := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
lastUploadDateStart
	^ lastUploadDateStart! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
lastUploadDateStart: anObject 
	lastUploadDateStart := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
licence
	^ licence! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
licence: anObject 
	licence := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'comparing' stamp: ''!
matches: aDidacticMaterial 
	self title
		ifNotNil: [aDidacticMaterial title = self title
				ifFalse: [^ false]].
	self creationDateStart
		ifNotNil: [aDidacticMaterial creationDate > self creationDateStart
				ifFalse: [^ false]].
	self creationDateEnd
		ifNotNil: [aDidacticMaterial creationDate < self creationDateEnd
				ifFalse: [^ false]].
	self lastUploadDateStart
		ifNotNil: [aDidacticMaterial lastUploadDate > self lastUploadDateStart
				ifFalse: [^ false]].
	self lastUploadDateEnd
		ifNotNil: [aDidacticMaterial lastUploadDate < self lastUploadDateEnd
				ifFalse: [^ false]].
	self materialDescription
		ifNotNil: [aDidacticMaterial materialDescription = self materialDescription
				ifFalse: [^ false]].
	self owner
		ifNotNil: [aDidacticMaterial owner email = self owner
				ifFalse: [^ false]].
	self authors
		ifNotNil: [(aDidacticMaterial authors includesAnyOf: self authors)
				ifFalse: [^ false]].
	self licence
		ifNotNil: [aDidacticMaterial licence = self licence
				ifFalse: [^ false]].
	self type
		ifNotNil: [aDidacticMaterial type = self type
				ifFalse: [^ false]].
	self tags
		ifNotNil: [(aDidacticMaterial tags includesAnyOf: self tags)
				ifFalse: [^ false]].
	^ true! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
materialDescription
	^ materialDescription! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
materialDescription: anObject 
	materialDescription := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
owner
	^ owner! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
owner: anObject 
	owner := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
tags
	^ tags! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
tags: anObject 
	tags := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
title
	^ title! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
title: anObject 
	title := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
type
	^ type! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: ''!
type: anObject 
	type := anObject! !

SearchSpecs subclass: #GroupSearchSpecs
	instanceVariableNames: 'creator ownerList visible topic userList instructor groupName beginDateStart EndDateStart beginDateEnd EndDateEnd materialList courseIdentifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:56'!
beginDateEnd
	^ beginDateEnd! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:56'!
beginDateEnd: anObject
	beginDateEnd := anObject! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:56'!
beginDateStart
	^ beginDateStart! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:56'!
beginDateStart: anObject
	beginDateStart := anObject! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:48'!
courseIdentifier
	^ courseIdentifier! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:48'!
courseIdentifier: anObject
	courseIdentifier := anObject! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:24'!
creator
	^ creator! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:24'!
creator: anObject
	creator := anObject! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:56'!
endDateEnd
	^ EndDateEnd! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:56'!
endDateEnd: anObject
	EndDateEnd := anObject! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:56'!
endDateStart
	^ EndDateStart! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:56'!
endDateStart: anObject
	EndDateStart := anObject! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:24'!
groupName
	^ groupName! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:24'!
groupName: anObject
	groupName := anObject! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:24'!
instructor
	^ instructor! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:24'!
instructor: anObject
	instructor := anObject! !

!GroupSearchSpecs methodsFor: 'comparing' stamp: 'Su 7/1/2013 04:04'!
matches: aGroup
	self groupName   
		ifNotNil: [aGroup groupName  = self groupName
				ifFalse: [^ false]].
	self beginDateStart
		ifNotNil: [aGroup beginDate  > self beginDateStart
				ifFalse: [^ false]].
	self beginDateEnd
		ifNotNil: [aGroup beginDate < self beginDateEnd
				ifFalse: [^ false]].
	self endDateStart
		ifNotNil: [aGroup endDate > self endDateStart
				ifFalse: [^ false]].
	self endDateEnd
		ifNotNil: [aGroup endDate < self endDateEnd
				ifFalse: [^ false]].
	self materialList
		ifNotNil: [aGroup materialList= self materialList
				ifFalse: [^ false]].
	self creator
		ifNotNil: [aGroup creator = self creator
				ifFalse: [^ false]].
	self topic
		ifNotNil: [(aGroup topic includesAnyOf: self topic)
				ifFalse: [^ false]].
	self instructor 
		ifNotNil: [aGroup instructor = self instructor
				ifFalse: [^ false]].
	self userList  
		ifNotNil: [aGroup userList = self userList  
				ifFalse: [^ false]].
	self ownerList  
		ifNotNil: [(aGroup ownerList = self ownerList)
				ifFalse: [^ false]].
	self courseIdentifier    
		ifNotNil: [(aGroup courseIdentifier = self courseIdentifier)
				ifFalse: [^ false]].
	^ true! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:48'!
materialList
	^ materialList! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:48'!
materialList: anObject
	materialList := anObject! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:24'!
ownerList
	^ ownerList! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:24'!
ownerList: anObject
	ownerList := anObject! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:24'!
topic
	^ topic! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:24'!
topic: anObject
	topic := anObject! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:24'!
userList
	^ userList! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:24'!
userList: anObject
	userList := anObject! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:24'!
visible
	^ visible! !

!GroupSearchSpecs methodsFor: 'accessing' stamp: 'Su 7/1/2013 03:24'!
visible: anObject
	visible := anObject! !

!SearchSpecs methodsFor: 'comparing' stamp: ''!
matches: anObject 
	^ self! !

SearchSpecs subclass: #UserSearchSpecs
	instanceVariableNames: 'userName email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!UserSearchSpecs methodsFor: 'accessing' stamp: ''!
email
	^ email! !

!UserSearchSpecs methodsFor: 'accessing' stamp: ''!
email: anObject 
	email := anObject! !

!UserSearchSpecs methodsFor: 'as yet unclassified' stamp: ''!
matches: anUser 
	self userName
		ifNotNil: [anUser userName = self userName
				ifFalse: [^ false]].
	self email
		ifNotNil: [anUser email = self email
				ifFalse: [^ false]].
	^ true! !

!UserSearchSpecs methodsFor: 'accessing' stamp: ''!
userName
	^ userName! !

!UserSearchSpecs methodsFor: 'accessing' stamp: ''!
userName: anObject 
	userName := anObject! !

Object subclass: #System
	instanceVariableNames: 'TopicTable TopicToBeAproved UserTable'
	classVariableNames: 'Id Single'
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!System commentStamp: 'RFG 5/2/2013 13:21' prior: 0!
The main class representing the own system.!

!System class methodsFor: 'initialization' stamp: ''!
create
	Single isNil
		ifTrue: [Single := self new.
			Single TopicTable: Dictionary new.
			Single UserTable: Dictionary new.
			Single TopicToBeAproved: OrderedCollection new].
	^ Single! !

!System class methodsFor: 'id management' stamp: ''!
nextId
	Id isNil
		ifTrue: [Id := 0]
		ifFalse: [Id := Id + 1].
	^ Id! !

!System class methodsFor: 'initialization' stamp: ''!
reset
	| newSys |
	Single := nil.
	newSys := System create.
	^ newSys! !

!System methodsFor: 'accessing' stamp: ''!
TopicTable
	^ TopicTable! !

!System methodsFor: 'accessing' stamp: ''!
TopicTable: aDictionary 
	TopicTable := aDictionary! !

!System methodsFor: 'accessing' stamp: ''!
TopicToBeAproved: aCollection 
	^ TopicToBeAproved := aCollection! !

!System methodsFor: 'accessing' stamp: ''!
UserTable
	^ UserTable! !

!System methodsFor: 'accessing' stamp: ''!
UserTable: aDictionary 
	UserTable := aDictionary! !

!System methodsFor: 'adding' stamp: ''!
addTopic: aTopic 
	TopicTable at: aTopic id put: aTopic.
	TopicToBeAproved addLast: aTopic id! !

!System methodsFor: 'adding' stamp: ''!
addUser: anUser 
	UserTable at: anUser id put: anUser! !

!System methodsFor: 'accessing' stamp: ''!
findCourse: anId 
	| anArray aTopic aCourse index |
	index := 1.
	anArray := TopicTable associations.
	[index <= anArray size]
		whileTrue: [aTopic := anArray at: index.
			aCourse := aTopic value findCourse: anId.
			aCourse notNil
				ifTrue: [^ aCourse].
			index := index + 1].
	^ (KeyNotFound key: anId) signal! !

!System methodsFor: 'accessing' stamp: ''!
findGroup: anId 
	| isThere group |
	TopicTable
		do: [:topic | topic subjectTable
				do: [:subject | 
					isThere := subject groupTable includesKey: anId.
					isThere
						ifTrue: [group := subject groupTable at: anId]]].
	group isNil
		ifTrue: [^ (KeyNotFound key: anId) signal].
	^ group! !

!System methodsFor: 'accessing' stamp: ''!
findLecture: anId 
	| isThere lecture |
	TopicTable
		do: [:topic | topic subjectTable
				do: [:subject | 
					isThere := subject lectureTable includesKey: anId.
					isThere
						ifTrue: [lecture := subject lectureTable at: anId]]].
	lecture isNil
		ifTrue: [^ (KeyNotFound key: anId) signal].
	^ lecture! !

!System methodsFor: 'accessing' stamp: ''!
findSubject: anId 
	| anArray aTopic aSubject index |
	index := 1.
	anArray := TopicTable associations.
	[index <= anArray size]
		whileTrue: [aTopic := anArray at: index.
			aSubject := aTopic value findSubject: anId.
			aSubject notNil
				ifTrue: [^ aSubject].
			index := index + 1].
	^ (KeyNotFound key: anId) signal! !

!System methodsFor: 'accessing' stamp: ''!
findTopic: anId 
	^ TopicTable at: anId! !

!System methodsFor: 'accessing' stamp: ''!
findUser: anId 
	^ UserTable at: anId! !

!System methodsFor: 'removing' stamp: ''!
removeTopic: anId 
	TopicTable removeKey: anId! !

!System methodsFor: 'removing' stamp: ''!
removeUser: anId 
	UserTable removeKey: anId! !

!System methodsFor: 'accessing' stamp: ''!
topicToModerator
	^ TopicToBeAproved at: 1! !

Object subclass: #TopicManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

Object subclass: #User
	instanceVariableNames: 'id name courseList groupList contentList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!User commentStamp: 'RFG 5/2/2013 11:22' prior: 0!
Represents a user in the system.!

User subclass: #Moderator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!Moderator commentStamp: 'RFG 5/11/2013 12:24' prior: 0!
Represents a topic moderator in the system.!

Moderator subclass: #Administrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!Administrator commentStamp: 'RFG 5/11/2013 14:52' prior: 0!
Represents special users who can create topics and erase/create anything.!

!Administrator methodsFor: 'creation' stamp: ''!
createTopic: aName withId: anId by: userId 
	| sys aTopic |
	aTopic := Topic
				newNamed: aName
				withId: anId
				by: userId.
	sys := System create.
	sys addTopic: aTopic! !

!Administrator methodsFor: 'creation' stamp: ''!
createTopic: aName withId: anId created: userId 
	| sys aTopic |
	aTopic := Topic
				newNamed: aName
				withId: anId
				by: userId.
	sys := System create.
	sys addTopic: aTopic! !

!Administrator methodsFor: 'creation' stamp: ''!
createUser: aName withId: anId 
	| newUser sys |
	newUser := User newNamed: aName withId: anId.
	sys := System create.
	sys addUser: newUser! !

!Administrator methodsFor: 'nominate' stamp: ''!
nominateAdministrator: anUser 
	| newAdministrator sys |
	newAdministrator := Administrator newNamed: anUser name withId: anUser id.
	newAdministrator courseList: anUser courseList.
	newAdministrator groupList: anUser groupList.
	newAdministrator contentList: anUser contentList.
	sys := System create.
	sys removeUser: anUser id.
	sys addUser: newAdministrator id.
	^ newAdministrator! !

!Administrator methodsFor: 'nominate' stamp: ''!
nominateModerator: anUser onTopic: aTopicId 
	| newModerator sys aTopic |
	newModerator := Moderator newNamed: anUser name withId: anUser id.
	newModerator courseList: anUser courseList.
	newModerator groupList: anUser groupList.
	newModerator contentList: anUser contentList.
	sys := System create.
	sys removeUser: anUser id.
	sys addUser: newModerator.
	aTopic := sys findTopic: aTopicId.
	aTopic addModerator: newModerator id.
	^ newModerator! !

!Moderator methodsFor: 'publishing' stamp: ''!
aproveTopic
	| anId aTopic sys |
	sys := System create.
	anId := sys topicToModerator.
	aTopic := sys findTopic: anId.
	aTopic visible: true! !

!Moderator methodsFor: 'publishing' stamp: ''!
hide: aDidaticStructure 
	| topic system mod |
	system := System create.
	topic := system findTopic: aDidaticStructure topic.
	mod := topic moderatorList at: self id.
	mod isNil
		ifFalse: [aDidaticStructure visible: True]! !

!Moderator methodsFor: 'publishing' stamp: ''!
publish: aDidaticStructure 
	| topic system mod |
	system := System create.
	topic := system findTopic: aDidaticStructure topic.
	mod := topic moderatorList at: self id.
	mod isNil
		ifFalse: [aDidaticStructure visible: True]! !

!User class methodsFor: 'instance creation' stamp: ''!
newNamed: aName withId: anId 
	| newUser sys |
	newUser := self new.
	newUser id: anId.
	newUser name: aName.
	newUser groupList isNil
		ifTrue: [newUser groupList: OrderedCollection new].
	newUser courseList isNil
		ifTrue: [newUser courseList: OrderedCollection new].
	newUser contentList isNil
		ifTrue: [newUser contentList: OrderedCollection new].
	sys := System create.
	sys addUser: newUser.
	^ newUser! !

!User methodsFor: 'accessing' stamp: ''!
contentList
	^ contentList! !

!User methodsFor: 'accessing' stamp: ''!
contentList: anOrderedCollection 
	contentList := anOrderedCollection! !

!User methodsFor: 'accessing' stamp: ''!
courseList
	^ courseList! !

!User methodsFor: 'accessing' stamp: ''!
courseList: anOrderedCollection 
	courseList := anOrderedCollection! !

!User methodsFor: 'deletion' stamp: ''!
delete
	| sys |
	sys := System create.
	sys removeUser: self Id.
	courseList
		do: [:course | course removeUser: self id].
	groupList
		do: [:group | group removeUser: self id]! !

!User methodsFor: 'remotion' stamp: ''!
delete: aDidaticStructure 
	aDidaticStructure ownerList
		remove: id
		ifAbsent: [Transcript show: 'User can not do that.'].
	aDidaticStructure delete! !

!User methodsFor: 'subscription' stamp: ''!
enrollCourse: courseId 
	| sys aCourse |
	self courseList add: courseId.
	sys := System create.
	aCourse := sys findCourse: courseId.
	aCourse addUser: self Id! !

!User methodsFor: 'subscription' stamp: ''!
enterGroup: aGroupId 
	^ self! !

!User methodsFor: 'accessing' stamp: ''!
groupList
	^ groupList! !

!User methodsFor: 'accessing' stamp: ''!
groupList: anOrderedCollection 
	groupList := anOrderedCollection! !

!User methodsFor: 'accessing' stamp: ''!
id
	^ id! !

!User methodsFor: 'accessing' stamp: ''!
id: anId 
	id := anId! !

!User methodsFor: 'subscription' stamp: ''!
leaveGroup: aGroupId 
	| group system |
	system := System create.
	group := system findGroup: aGroupId.
	group removeUser: id.
	groupList remove: aGroupId! !

!User methodsFor: 'accessing' stamp: ''!
name
	^ name! !

!User methodsFor: 'accessing' stamp: ''!
name: aName 
	name := aName! !

!User methodsFor: 'subscription' stamp: ''!
watchLecture: aLectureId 
	| lecture |
	lecture := System findLecture: aLectureId.
	lecture userList add: self id! !

!User methodsFor: 'subscription' stamp: ''!
withdrawCourse: aCourseId 
	| course system |
	system := System create.
	course := system findCourse: aCourseId.
	course userList remove: id.
	courseList remove: aCourseId! !

Object subclass: #UserManager
	instanceVariableNames: 'session users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!UserManager methodsFor: 'permission' stamp: 'jsa 7/1/2013 02:37'!
canChangeUserEmail: anUser 
	^ self isLoggedUserOrAdmin: anUser.  ! !

!UserManager methodsFor: 'permission' stamp: 'jsa 7/1/2013 02:38'!
canChangeUserName: anUser 
	^ self isLoggedUserOrAdmin: anUser.! !

!UserManager methodsFor: 'permission' stamp: 'jsa 7/1/2013 02:38'!
canChangeUserPassword: anUser 
	^ self isLoggedUserOrAdmin: anUser.! !

!UserManager methodsFor: 'permission' stamp: 'jsa 7/1/2013 02:38'!
canEditMaterial: userOwner 
	^ self isLoggedUserOrAdmin: userOwner.! !

!UserManager methodsFor: 'permission' stamp: 'jsa 7/1/2013 02:39'!
canRemoveMaterial: userOwner 
	^ self isLoggedUserOrAdmin: userOwner.! !

!UserManager methodsFor: 'permission' stamp: 'jsa 7/1/2013 02:39'!
canRemoveUser: userToRemove 
	^ self isLoggedUserOrAdmin: userToRemove.! !

!UserManager methodsFor: 'permission' stamp: 'jsa 7/1/2013 02:39'!
canSubmitMaterial
	^ session user isNil not! !

!UserManager methodsFor: 'editing' stamp: ''!
changeEmail: user newEmail: newEmail 
	user id
		ifNil: [Error signal: 'User id is nil'].
	(self
			search: (UserSearchSpecs new email: newEmail)) size > 0
		ifTrue: [Error signal: 'email already used by another user.']
		ifFalse: [(self canChangeUserEmail: user)
				ifTrue: [users
						edit: (user email: newEmail)]
				ifFalse: [Error signal: 'User doesn''t have permission to change this email.']]! !

!UserManager methodsFor: 'editing' stamp: ''!
changeName: anUser newName: newName 
	anUser id
		ifNil: [Error signal: 'User id is nil'].
	(self
			search: (UserSearchSpecs new userName: newName)) size > 0
		ifTrue: [Error signal: 'name already used by another user.']
		ifFalse: [(self canChangeUserName: anUser)
				ifTrue: [users
						edit: (anUser userName: newName)]
				ifFalse: [Error signal: 'User doesn''t have permission to change this name.']]! !

!UserManager methodsFor: 'editing' stamp: ''!
changePassword: anUser newPassword: newPassword 
	anUser id
		ifNil: [Error signal: 'User id is nil'].
	(self canChangeUserPassword: anUser)
		ifTrue: [anUser password: newPassword.
			users edit: anUser]
		ifFalse: [Error signal: 'User doesn''t have permission to change this password.']! !

!UserManager methodsFor: 'private' stamp: ''!
hasUser: aUser 
	^ users includes: aUser! !

!UserManager methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	users := OcImageDatabase new users! !

!UserManager methodsFor: 'as yet unclassified' stamp: 'jsa 7/1/2013 02:58'!
isLoggedUserOrAdmin: anUser
	self session user
		ifNotNil: [^ self session user = anUser or: self session user = OcImageDatabase new admin].
	^ false! !

!UserManager methodsFor: 'authentication' stamp: 'jsa 7/1/2013 03:01'!
login: nameOrEmail password: password 
	| registeredUser userSpecs searchResult |
	OcImageDatabase new admin
		ifNil: [(nameOrEmail = 'admin' and: password = 'admin')
				ifTrue: [self registerDefaultAdmin]].
	userSpecs := UserSearchSpecs new email: nameOrEmail.
	searchResult := users findBySpec: userSpecs.
	searchResult size = 0
		ifTrue: [userSpecs := UserSearchSpecs new userName: nameOrEmail.
			searchResult := users findBySpec: userSpecs.
			searchResult size = 0
				ifTrue: [Error signal: 'User/Password incorrect!!']].
	registeredUser := searchResult anyOne.
	password = registeredUser password
		ifTrue: [session user: registeredUser]
		ifFalse: [Error signal: 'User/Password incorrect!!']! !

!UserManager methodsFor: 'managing' stamp: 'jsa 7/1/2013 01:36'!
registerDefaultAdmin
	self
		registerNewUser: 'admin'
		password: (OcUser hashPassword: 'admin')
		email: 'admin'.
	OcImageDatabase new admin: (users
			findBySpec: (UserSearchSpecs new email: 'admin')) anyOne! !

!UserManager methodsFor: 'managing' stamp: 'jsa 7/1/2013 01:10'!
registerNewUser: name password: password email: email 
	| newUser |
	newUser := OcUser new userName: name;
				 password: password;
				 email: email.
	Transcript show: 'Oi'; cr.
	((self
			search: (UserSearchSpecs new userName: name)) size > 0 or: (self
				search: (UserSearchSpecs new email: email)) size > 0)
		ifTrue: [^ nil]
		ifFalse: [newUser generateId.
			users add: newUser.
			^ newUser]! !

!UserManager methodsFor: 'managing' stamp: 'jsa 7/1/2013 02:56'!
removeUser: anUser 
	anUser id
		ifNil: [Error signal: 'User id is nil'].
	(self canRemoveUser: anUser)
		ifTrue: [users remove: anUser.
			self session user = anUser
				ifTrue: [self session logout]]
		ifFalse: [Error signal: 'User doesn''t have permission to remove this user']! !

!UserManager methodsFor: 'as yet unclassified' stamp: ''!
search: anUserSpec 
	^ users findBySpec: anUserSpec! !

!UserManager methodsFor: 'accessing' stamp: 'jsa 7/1/2013 02:02'!
session
	^ session! !

!UserManager methodsFor: 'accessing' stamp: 'jsa 7/1/2013 02:02'!
session: anObject
	session := anObject! !

!UserManager methodsFor: 'accessing' stamp: ''!
users
	^ users! !

!UserManager methodsFor: 'accessing' stamp: ''!
users: anObject 
	users := anObject! !

!UserManager methodsFor: 'authentication' stamp: 'jsa 7/1/2013 03:12'!
validateLogin: nameOrEmail password: password 
	| registeredUser userSpecs searchResult |
	OcImageDatabase new admin
		ifNil: [(nameOrEmail = 'admin' and: password = (OcUser hashPassword: 'admin'))
				ifTrue: [self registerDefaultAdmin]].
	userSpecs := UserSearchSpecs new email: nameOrEmail.
	searchResult := users findBySpec: userSpecs.
	searchResult size = 0
		ifTrue: [userSpecs := UserSearchSpecs new userName: nameOrEmail.
			searchResult := users findBySpec: userSpecs.
			searchResult size = 0
				ifTrue: [^ nil]].
	registeredUser := searchResult anyOne.
	password = registeredUser password
		ifTrue: [^ registeredUser]
		ifFalse: [^ nil]! !

WASession subclass: #OcSession
	instanceVariableNames: 'user database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcSession methodsFor: 'accessing' stamp: ''!
database
	^ database! !

!OcSession methodsFor: 'accessing' stamp: ''!
database: anObject 
	database := anObject! !

!OcSession methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self database: OcImageDatabase new! !

!OcSession methodsFor: 'as yet unclassified' stamp: ''!
isLoggedIn
	^ self user notNil! !

!OcSession methodsFor: 'as yet unclassified' stamp: ''!
login: aUser 
	self user: aUser! !

!OcSession methodsFor: 'as yet unclassified' stamp: ''!
logout
	self user: nil! !

!OcSession methodsFor: 'as yet unclassified' stamp: ''!
responseForRequest: aRequest 
	self database connectionFailed
		ifTrue: [^ WAResponse new nextPutAll: 'No Database Connection'].
	^ super responseForRequest: aRequest! !

!OcSession methodsFor: 'parent/child' stamp: ''!
unregistered
	self database disconnect.
	super unregistered! !

!OcSession methodsFor: 'updating' stamp: ''!
updateRoot: anHtmlRoot 
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: OcLibrary applicationName! !

!OcSession methodsFor: 'accessing' stamp: ''!
user
	^ user! !

!OcSession methodsFor: 'accessing' stamp: ''!
user: anObject 
	user := anObject! !

TestCase subclass: #MaterialManagerTest
	instanceVariableNames: 'session emptyMaterialList nonEmptyMaterialList materialManager authorsList submittedFile tags database userManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Tests'!

!MaterialManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 7/1/2013 03:02'!
loginAsAdmin
	session login: (userManager validateLogin: 'admin' password: (OcUser hashPassword: 'admin')).! !

!MaterialManagerTest methodsFor: 'running' stamp: 'jsa 7/1/2013 03:02'!
setUp
	session := OcSession new.
	userManager := UserManager new session: session.  
	database := OcImageDatabaseMock new.
	database blankData.
	emptyMaterialList := database materials copy.
	database blankData.
	materialManager := MaterialManager new.
	materialManager session: session.  
	materialManager materials: database materials.
	session
		user: (OcUser new email: 'anuser@email.com'; generateId).
	authorsList := OrderedCollection new.
	authorsList add: 'an author1';
		 add: 'an author2';
		 add: 'an author3'.
	submittedFile := FakeFile new title: 'a file title';
				 contents: ByteArray new.
	tags := SortedCollection new.
	tags add: 'DNA';
		 add: 'RNA';
		 add: 'Molecular Biology'.
	materialManager
		submitMaterial: submittedFile
		title: 'a title'
		authors: authorsList
		description: 'a description'
		type: 'class note'
		licence: 'GPLv3'
		tags: tags.
	session
		user: (OcUser new email: 'user@email.com'; generateId).
	authorsList := OrderedCollection new.
	authorsList add: 'author1';
		 add: 'author2'.
	submittedFile := FakeFile new title: 'file title';
				 contents: ByteArray new.
	tags := SortedCollection new.
	tags add: 'OOP';
		 add: 'Smalltalk'.
	materialManager
		submitMaterial: submittedFile
		title: 'title'
		authors: authorsList
		description: 'description'
		type: 'slide show'
		licence: 'GPLv3'
		tags: tags.
	nonEmptyMaterialList := materialManager materials copy! !

!MaterialManagerTest methodsFor: 'editing' stamp: ''!
testEditMaterialEverythingButTitle
	| newAuthorsList newSubmittedFile newTags editedMaterialSpec oldMaterialSpec |
	newAuthorsList := OrderedCollection new add: 'new';
				 add: 'authors'.
	newSubmittedFile := FakeFile new title: 'new file title';
				 contents: ByteArray new.
	newTags := SortedCollection new add: 'new';
				 add: 'tags'.
	editedMaterialSpec := DidacticMaterialSearchSpecs new title: 'title';
				 materialDescription: 'new description'.
	oldMaterialSpec := DidacticMaterialSearchSpecs new title: 'title';
				 materialDescription: 'description'.
	self assert: (materialManager search: editedMaterialSpec) size == 0.
	self assert: (materialManager search: oldMaterialSpec) size == 1.
	(materialManager search: oldMaterialSpec)
		do: [:material | materialManager editMaterial: (OcDidacticMaterial new id: material id;
					 materialDescription: 'new description')].
	self assert: (materialManager search: editedMaterialSpec) size == 1.
	self assert: (materialManager search: oldMaterialSpec) size == 0! !

!MaterialManagerTest methodsFor: 'editing' stamp: 'jsa 7/1/2013 03:03'!
testEditMaterialLoggedAsAdmin
	| editedMaterialSpec oldMaterialSpec |
	self loginAsAdmin.
	materialManager session: session.
	editedMaterialSpec := DidacticMaterialSearchSpecs new title: 'new title'.
	oldMaterialSpec := DidacticMaterialSearchSpecs new title: 'title'.
	self assert: (materialManager search: editedMaterialSpec) size == 0.
	self assert: (materialManager search: oldMaterialSpec) size == 1.
	(materialManager search: oldMaterialSpec)
		do: [:material | materialManager editMaterial: (OcDidacticMaterial new id: material id;
					 title: 'new title')].
	self assert: (materialManager search: editedMaterialSpec) size == 1.
	self assert: (materialManager search: oldMaterialSpec) size == 0! !

!MaterialManagerTest methodsFor: 'editing' stamp: 'jsa 7/1/2013 03:00'!
testEditMaterialLoggedAsDifferentUser
	| editedMaterialSpec oldMaterialSpec |
	session
		user: (OcUser new id: -1).
	editedMaterialSpec := DidacticMaterialSearchSpecs new title: 'new title'.
	oldMaterialSpec := DidacticMaterialSearchSpecs new title: 'title'.
	self assert: (materialManager search: editedMaterialSpec) size == 0.
	self assert: (materialManager search: oldMaterialSpec) size == 1.
	(materialManager search: oldMaterialSpec)
		do: [:material | self
				should: [materialManager editMaterial: (OcDidacticMaterial new id: material id;
							 title: 'new title')]
				raise: Error].
	self assert: (materialManager search: editedMaterialSpec) size == 0.
	self assert: (materialManager search: oldMaterialSpec) size == 1! !

!MaterialManagerTest methodsFor: 'editing' stamp: ''!
testEditMaterialTitle
	| editedMaterialSpec oldMaterialSpec |
	editedMaterialSpec := DidacticMaterialSearchSpecs new title: 'new title'.
	oldMaterialSpec := DidacticMaterialSearchSpecs new title: 'title'.
	self assert: (materialManager search: editedMaterialSpec) size == 0.
	self assert: (materialManager search: oldMaterialSpec) size == 1.
	(materialManager search: oldMaterialSpec)
		do: [:material | materialManager editMaterial: (OcDidacticMaterial new id: material id;
					 title: 'new title')].
	self assert: (materialManager search: editedMaterialSpec) size == 1.
	self assert: (materialManager search: oldMaterialSpec) size == 0! !

!MaterialManagerTest methodsFor: 'editing' stamp: ''!
testEditMaterialTitleThatDoesntExist
	| editedMaterialSpec |
	editedMaterialSpec := DidacticMaterialSearchSpecs new title: 'new title'.
	self
		shouldnt: [materialManager materials
				includes: (OcDidacticMaterial new id: -1)].
	self
		should: [materialManager editMaterial: (OcDidacticMaterial new id: -1;
					 title: 'new title')]
		raise: Error.
	self assert: (materialManager search: editedMaterialSpec) size == 0! !

!MaterialManagerTest methodsFor: 'editing' stamp: 'jsa 7/1/2013 03:00'!
testEditMaterialWithoutLogin
	| editedMaterialSpec oldMaterialSpec |
	session user: nil.
	editedMaterialSpec := DidacticMaterialSearchSpecs new title: 'new title'.
	oldMaterialSpec := DidacticMaterialSearchSpecs new title: 'title'.
	self assert: (materialManager search: editedMaterialSpec) size == 0.
	self assert: (materialManager search: oldMaterialSpec) size == 1.
	(materialManager search: oldMaterialSpec)
		do: [:material | self
				should: [materialManager editMaterial: (OcDidacticMaterial new id: material id;
							 title: 'new title')]
				raise: Error].
	self assert: (materialManager search: editedMaterialSpec) size == 0.
	self assert: (materialManager search: oldMaterialSpec) size == 1! !

!MaterialManagerTest methodsFor: 'removing' stamp: ''!
testRemoveMaterial
	| materialSpec |
	materialSpec := DidacticMaterialSearchSpecs new title: 'title'.
	self assert: (materialManager search: materialSpec) size == 1.
	(materialManager search: materialSpec)
		do: [:material | materialManager removeMaterial: material].
	self assert: (materialManager search: materialSpec) size == 0! !

!MaterialManagerTest methodsFor: 'removing' stamp: 'jsa 7/1/2013 03:03'!
testRemoveMaterialLoggedAsAdmin
	| materialSpec |
	self loginAsAdmin.
	materialSpec := DidacticMaterialSearchSpecs new title: 'title'.
	self assert: (materialManager search: materialSpec) size == 1.
	(materialManager search: materialSpec)
		do: [:material | materialManager removeMaterial: material].
	self assert: (materialManager search: materialSpec) size == 0! !

!MaterialManagerTest methodsFor: 'removing' stamp: 'jsa 7/1/2013 03:03'!
testRemoveMaterialLoggedAsDifferentUser
	| materialSpec |
	session
		user: (OcUser new id: '-1').
	materialSpec := DidacticMaterialSearchSpecs new title: 'title'.
	self assert: (materialManager search: materialSpec) size == 1.
	(materialManager search: materialSpec)
		do: [:material | self
				should: [materialManager removeMaterial: material]
				raise: Error].
	self assert: (materialManager search: materialSpec) size == 1! !

!MaterialManagerTest methodsFor: 'removing' stamp: ''!
testRemoveMaterialThatDoesntExist
	| numberOfMaterials |
	numberOfMaterials := materialManager materials list size.
	self
		shouldnt: [materialManager materials
				includes: (OcDidacticMaterial new id: -1)].
	self
		should: [materialManager
				editMaterial: (OcDidacticMaterial new id: -1)]
		raise: Error.
	self assert: materialManager materials list size == numberOfMaterials! !

!MaterialManagerTest methodsFor: 'removing' stamp: 'jsa 7/1/2013 03:04'!
testRemoveMaterialWithoutLogin
	| materialSpec |
	session user: nil.
	materialSpec := DidacticMaterialSearchSpecs new title: 'title'.
	self assert: (materialManager search: materialSpec) size == 1.
	(materialManager search: materialSpec)
		do: [:material | self
				should: [materialManager removeMaterial: material]
				raise: Error].
	self assert: (materialManager search: materialSpec) size == 1! !

!MaterialManagerTest methodsFor: 'searching' stamp: ''!
testSearchByAuthors
	| searchSpecsNoResult searchSpecsWithResult |
	authorsList := OrderedCollection new.
	authorsList add: 'wrong author'.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new authors: authorsList.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	authorsList add: 'author1'.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new authors: authorsList.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.
	authorsList add: 'author2'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.
	authorsList add: 'an author3'.
	self assert: (materialManager search: searchSpecsWithResult) size == 2! !

!MaterialManagerTest methodsFor: 'searching' stamp: ''!
testSearchByCreationDate
	| searchSpecsNoResult searchSpecsWithResult |
	searchSpecsNoResult := DidacticMaterialSearchSpecs new
				creationDateStart: (TimeStamp now plusSeconds: 4);
				
				creationDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new
				creationDateStart: (TimeStamp now minusSeconds: 14);
				
				creationDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsWithResult) size == 2! !

!MaterialManagerTest methodsFor: 'searching' stamp: ''!
testSearchByDescription
	| searchSpecsNoResult searchSpecsWithResult |
	searchSpecsNoResult := DidacticMaterialSearchSpecs new materialDescription: 'wrong description'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new materialDescription: 'description'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1! !

!MaterialManagerTest methodsFor: 'searching' stamp: ''!
testSearchByLastUploadDate
	| searchSpecsNoResult searchSpecsWithResult |
	searchSpecsNoResult := DidacticMaterialSearchSpecs new
				lastUploadDateStart: (TimeStamp now plusSeconds: 4);
				
				lastUploadDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new
				lastUploadDateStart: (TimeStamp now minusSeconds: 14);
				
				lastUploadDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsWithResult) size == 2! !

!MaterialManagerTest methodsFor: 'searching' stamp: ''!
testSearchByLicence
	| searchSpecsNoResult searchSpecsWithResult |
	materialManager materials
		add: (OcDidacticMaterial new licence: 'none').
	searchSpecsNoResult := DidacticMaterialSearchSpecs new licence: 'wrong licence'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new licence: 'none'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new licence: 'GPLv3'.
	self assert: (materialManager search: searchSpecsWithResult) size == 2! !

!MaterialManagerTest methodsFor: 'searching' stamp: ''!
testSearchByOwner
	| searchSpecsNoResult searchSpecsWithResult |
	searchSpecsNoResult := DidacticMaterialSearchSpecs new owner: 'wrong_owner@email.com'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new owner: 'user@email.com'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1! !

!MaterialManagerTest methodsFor: 'searching' stamp: ''!
testSearchByTags
	| searchSpecsNoResult searchSpecsWithResult |
	tags := SortedCollection new.
	authorsList add: 'wrong tag'.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new tags: tags.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	tags := OrderedCollection new.
	tags add: 'OOP'.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new tags: tags.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.
	authorsList add: 'Smalltalk'.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new tags: tags.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.
	tags add: 'DNA'.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new tags: tags.
	self assert: (materialManager search: searchSpecsWithResult) size == 2! !

!MaterialManagerTest methodsFor: 'searching' stamp: ''!
testSearchByTitle
	| searchSpecsNoResult searchSpecsWithResult |
	searchSpecsNoResult := DidacticMaterialSearchSpecs new title: 'wrong title'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new title: 'title'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1! !

!MaterialManagerTest methodsFor: 'searching' stamp: ''!
testSearchByTitleAndCreationDate
	| searchSpecsNoResult searchSpecsWithResult |
	searchSpecsNoResult := DidacticMaterialSearchSpecs new title: 'title';
				
				creationDateStart: (TimeStamp now plusSeconds: 4);
				
				creationDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new title: 'title';
				
				creationDateStart: (TimeStamp now minusSeconds: 14);
				
				creationDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsWithResult) size == 1! !

!MaterialManagerTest methodsFor: 'searching' stamp: ''!
testSearchByTitleAndLastUploadDate
	| searchSpecsNoResult searchSpecsWithResult |
	searchSpecsNoResult := DidacticMaterialSearchSpecs new title: 'title';
				
				lastUploadDateStart: (TimeStamp now plusSeconds: 4);
				
				lastUploadDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new title: 'title';
				
				lastUploadDateStart: (TimeStamp now minusSeconds: 14);
				
				lastUploadDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsWithResult) size == 1! !

!MaterialManagerTest methodsFor: 'searching' stamp: ''!
testSearchByType
	| searchSpecsNoResult searchSpecsWithResult |
	searchSpecsNoResult := DidacticMaterialSearchSpecs new type: 'wrong type'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new type: 'slide show'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1! !

!MaterialManagerTest methodsFor: 'submitting' stamp: ''!
testSubmitMaterial
	materialManager materials: emptyMaterialList.
	materialManager
		submitMaterial: submittedFile
		title: 'title'
		authors: authorsList
		description: 'description'
		type: 'slide show'
		licence: 'GPLv3'
		tags: tags.
	self assert: (materialManager
			search: (DidacticMaterialSearchSpecs new title: 'title')) size == 1! !

!MaterialManagerTest methodsFor: 'submitting' stamp: 'jsa 7/1/2013 03:04'!
testSubmitMaterialAutomaticFields
	| loggedUser now maxDuration |
	materialManager materials: emptyMaterialList.
	loggedUser := OcUser new email: 'user@email.com'.
	session user: loggedUser.
	maxDuration := Duration seconds: 1.
	now := TimeStamp now.
	materialManager
		submitMaterial: submittedFile
		title: 'title'
		authors: authorsList
		description: 'description'
		type: 'slide show'
		licence: 'GPLv3'
		tags: tags.
	self assert: (materialManager materials list
			select: [:material | material owner = loggedUser and: material creationDate - now < maxDuration and: material lastUploadDate - now < maxDuration]) size == 1! !

!MaterialManagerTest methodsFor: 'submitting' stamp: 'jsa 7/1/2013 03:04'!
testSubmitMaterialWithoutLogin
	materialManager materials: emptyMaterialList.
	session user: nil.
	self
		should: [materialManager
				submitMaterial: submittedFile
				title: 'title'
				authors: authorsList
				description: 'description'
				type: 'slide show'
				licence: 'GPLv3'
				tags: tags]
		raise: Error.
	self assert: (materialManager
			search: (DidacticMaterialSearchSpecs new title: 'title')) size == 0! !

TestCase subclass: #UserManagerTest
	instanceVariableNames: 'session emptyUserList nonEmptyUserList userManager database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Tests'!

!UserManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 7/1/2013 02:48'!
login: userName password: password
	session login: (userManager validateLogin: userName password: (OcUser hashPassword: password)).! !

!UserManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 7/1/2013 02:34'!
loginAsAdmin
	session login: (userManager validateLogin: 'admin' password: (OcUser hashPassword: 'admin')).! !

!UserManagerTest methodsFor: 'running' stamp: 'jsa 7/1/2013 02:48'!
setUp
	session := OcSession new.
	database := OcImageDatabaseMock new.
	database blankData.
	emptyUserList := database users copy.
	database blankData.
	userManager := UserManager new session: session.
	userManager
		registerNewUser: 'john'
		password: (OcUser hashPassword: '123admin')
		email: 'johnadmin@me.com'.
	nonEmptyUserList := database users copy.
	self login: 'johnadmin@me.com' password: '123admin'.
	database admin: nil! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 02:24'!
testChangeEmail
	| oldEmail |
	oldEmail := session user email.
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: oldEmail)) size == 1].
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: 'johnadmin@newemail.com')) size == 0].
	self
		should: [userManager changeEmail: session user newEmail: session user email]
		raise: Error.
	userManager changeEmail: session user newEmail: 'johnadmin@newemail.com'.
	self
		assert: [session user email = 'johnadmin@newemail.com'].
	self
		assert: [userManager users includes: session user].
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: 'johnadmin@newemail.com')) size == 1].
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: oldEmail)) size == 0]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 02:35'!
testChangeEmailLoggedAsAdmin
	| user oldEmail |
	user := session user.
	oldEmail := user email.
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: 'johnadmin@newemail.com')) size == 0].
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: oldEmail)) size == 1].
	self loginAsAdmin.
	self
		should: [userManager changeEmail: session user newEmail: session user email]
		raise: Error.
	userManager changeEmail: user newEmail: 'johnadmin@newemail.com'.
	self
		assert: [user email = 'johnadmin@newemail.com'].
	self
		assert: [userManager users includes: session user].
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: 'johnadmin@newemail.com')) size == 1].
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: oldEmail)) size == 0]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 02:31'!
testChangeEmailWithoutLogin
	| oldUser oldEmail |
	oldUser := session user.
	oldEmail := oldUser email.
	session user: nil.
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: oldEmail)) size == 1].
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: 'blabla')) size == 0].
	self
		should: [userManager changeEmail: oldUser newEmail: 'blabla']
		raise: Error.
	self
		assert: [userManager users includes: oldUser].
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: oldEmail)) size == 1].
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: 'blabla')) size == 0]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 02:32'!
testChangeEmailWithoutPermission
	| oldUser oldEmail |
	oldUser := session user.
	oldEmail := oldUser email.
	session
		user: (OcUser new id: -1).
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: oldEmail)) size == 1].
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: 'blabla')) size == 0].
	self
		should: [userManager changeEmail: oldUser newEmail: 'blabla']
		raise: Error.
	self
		assert: [userManager users includes: oldUser].
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: oldEmail)) size == 1].
	self
		assert: [(userManager
				search: (UserSearchSpecs new email: 'blabla')) size == 0]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 02:32'!
testChangeName
	| newName oldName |
	newName := 'new_name'.
	oldName := session user userName.
	self
		assert: [(userManager
				search: (UserSearchSpecs new userName: newName)) size == 0].
	self
		assert: [(userManager
				search: (UserSearchSpecs new userName: oldName)) size == 1].
	userManager changeName: session user newName: newName.
	self
		assert: [session user userName = newName].
	self
		assert: [userManager users includes: session user].
	self
		assert: [(userManager
				search: (UserSearchSpecs new userName: newName)) size == 1].
	self
		assert: [(userManager
				search: (UserSearchSpecs new userName: oldName)) size == 0]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 02:45'!
testChangeNameLoggedAsAdmin
	| user newName userSpecs |
	user := session user copy.
	userSpecs := UserSearchSpecs new userName: user userName.
	self loginAsAdmin.
	newName := 'new_name'.
	self
		assert: [(userManager search: userSpecs) size == 1].
	userManager changeName: user newName: newName.
	self
		assert: [session user email = 'admin'].
	self
		assert: [user userName = newName].
	self
		assert: [(userManager search: userSpecs) size == 0].
	self
		assert: [(userManager
				search: (userSpecs userName: newName)) size == 1]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 02:32'!
testChangeNameWithoutPermission
	| oldUser oldName |
	oldUser := session user.
	oldName := oldUser userName.
	session
		user: (OcUser new id: -1).
	self
		assert: [(userManager
				search: (UserSearchSpecs new userName: oldName)) size == 1].
	self
		assert: [(userManager
				search: (UserSearchSpecs new userName: 'blabla')) size == 0].
	self
		should: [userManager changeName: oldUser newName: 'blabla']
		raise: Error.
	self
		assert: [(userManager
				search: (UserSearchSpecs new userName: oldName)) size == 1].
	self
		assert: [(userManager
				search: (UserSearchSpecs new userName: 'blabla')) size == 0]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 02:32'!
testChangePassword
	| newPassword oldPassword |
	newPassword := 'new_password'.
	oldPassword := session user password.
	userManager changePassword: session user newPassword: newPassword.
	self
		assert: [session user password = newPassword].
	self
		assert: [userManager users includes: session user]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 02:35'!
testChangePasswordLoggedAsAdmin
	| newPassword oldUser |
	newPassword := 'new_password'.
	oldUser := session user.
	self loginAsAdmin.
	userManager changePassword: oldUser newPassword: newPassword.
	self
		assert: [session user email = 'admin'].
	self
		assert: [oldUser password = newPassword].
	self
		assert: [userManager users includes: oldUser]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 02:33'!
testChangePasswordWithoutLogin
	| oldUser oldPassword |
	oldUser := session user.
	oldPassword := oldUser password.
	session user: nil.
	self
		should: [userManager changePassword: oldUser newPassword: 'new_password']
		raise: Error.
	self
		assert: [session user isNil].
	self
		assert: [oldUser password = oldPassword]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 02:33'!
testChangePasswordWithoutPermission
	| oldUser oldPassword |
	oldUser := session user.
	oldPassword := oldUser password.
	session
		user: (OcUser new email: 'another_user@email.com').
	self
		should: [userManager changePassword: oldUser newPassword: 'new_password']
		raise: Error.
	self
		assert: [oldUser password = oldPassword]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 02:45'!
testFirstAdminLogin
	userManager users: emptyUserList.
	database admin: nil.
	session user: nil.
	self
		should: [self loginAsAdmin.
			session user = database admin and: database admin isNil not and: (userManager
					search: (UserSearchSpecs new email: 'admin')) size == 1].
	session user: nil.
	self
		should: [self loginAsAdmin.
			session user = database admin and: database admin isNil not and: (userManager
					search: (UserSearchSpecs new email: 'admin')) size == 1]! !

!UserManagerTest methodsFor: 'testing' stamp: ''!
testRegisterNewUser
	| userSpec |
	userSpec := UserSearchSpecs new userName: 'john';
				 email: 'johnadmin@me.com'.
	userManager users: emptyUserList.
	self
		assert: [(userManager search: userSpec) size == 0].
	userManager
		registerNewUser: 'john'
		password: '123admin'
		email: 'johnadmin@me.com'.
	self
		assert: [(userManager search: userSpec) size == 1]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 02:33'!
testRemoveUser
	| listSize currentUser |
	currentUser := session user.
	self
		should: [userManager
				removeUser: (OcUser new email: 'wrong@email.com')]
		raise: Error.
	session user: nil.
	self
		should: [userManager removeUser: currentUser]
		raise: Error.
	session user: currentUser.
	listSize := userManager users list size.
	userManager removeUser: currentUser.
	self
		assert: [listSize > userManager users list size]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 02:35'!
testRemoveUserLoggedAsAdmin
	| listSize currentUser |
	currentUser := session user.
	self loginAsAdmin.
	listSize := userManager users list size.
	userManager removeUser: currentUser.
	self
		assert: [listSize > userManager users list size].
	self
		assert: [session user email = 'admin']! !

!UserManagerTest methodsFor: 'testing' stamp: ''!
testSearchByEmail
	| searchSpecsNoResult searchSpecsWithResult |
	searchSpecsNoResult := UserSearchSpecs new email: 'wrong email'.
	self assert: (userManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := UserSearchSpecs new email: 'johnadmin@me.com'.
	self assert: (userManager search: searchSpecsWithResult) size == 1! !

!UserManagerTest methodsFor: 'testing' stamp: ''!
testSearchByName
	| searchSpecsNoResult searchSpecsWithResult |
	searchSpecsNoResult := UserSearchSpecs new userName: 'wrong name'.
	self assert: (userManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := UserSearchSpecs new userName: 'john'.
	self assert: (userManager search: searchSpecsWithResult) size == 1! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 01:40'!
testTryToRegisterAnAlreadyRegisteredUser
	userManager users: nonEmptyUserList.
	self
		should: [(userManager
				registerNewUser: 'jon'
				password: '123admin321'
				email: 'johnadmin@me.com') isNil]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 7/1/2013 02:53'!
testValidateLogin
	| loggedUser |
	self
		should: [(userManager validateLogin: 'emailDoesntExist' password: (OcUser hashPassword: '123admin')) isNil].
	self
		should: [(userManager validateLogin: 'johnadmin@me.com' password: (OcUser hashPassword: 'wrongPassword')) isNil].
	loggedUser := OcUser new email: 'johnadmin@me.com'.
	self
		should: [(userManager validateLogin: 'johnadmin@me.com' password: (OcUser hashPassword: '123admin')) email = 'johnadmin@me.com']! !
